unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    PulseOutLabel1: TLabel;
    PulseOutTrack1: TTrackBar;
    Panel2: TPanel;
    PulseOutLabel2: TLabel;
    PulseOutTrack2: TTrackBar;
    Panel3: TPanel;
    PulseOutLabel3: TLabel;
    PulseOutTrack3: TTrackBar;
    Panel4: TPanel;
    PulseOutLabel4: TLabel;
    PulseOutTrack4: TTrackBar;
    Panel5: TPanel;
    PulseOutLabel5: TLabel;
    PulseOutTrack5: TTrackBar;
    Panel6: TPanel;
    PulseOutLabel6: TLabel;
    PulseOutTrack6: TTrackBar;
    Panel7: TPanel;
    PulseOutLabel7: TLabel;
    PulseOutTrack7: TTrackBar;
    Panel8: TPanel;
    PulseOutLabel8: TLabel;
    PulseOutTrack8: TTrackBar;
    Panel9: TPanel;
    PulseOutLabel9: TLabel;
    PulseOutTrack9: TTrackBar;
    Panel10: TPanel;
    PulseOutLabel10: TLabel;
    PulseOutTrack10: TTrackBar;
    Panel11: TPanel;
    PulseOutLabel11: TLabel;
    PulseOutTrack11: TTrackBar;
    Panel12: TPanel;
    PulseOutLabel12: TLabel;
    PulseOutTrack12: TTrackBar;
    Panel13: TPanel;
    PulseOutLabel13: TLabel;
    PulseOutTrack13: TTrackBar;
    Panel14: TPanel;
    PulseOutLabel14: TLabel;
    PulseOutTrack14: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure PulseOutTrackChange(Sender: TObject);
  protected
    DeviceIndex: LongWord;
    TicksPerCycle: Word;
    PulseOutLabel: array[1..15] of TLabel;
    PulseOutTrack: array[1..15] of TTrackBar;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  AIOUSB,
  DetectUnit;

procedure TMainForm.FormCreate(Sender: TObject);
const
  BaseClock = 10000000;

var
  DetectForm: TDetectForm;
  Status: LongWord;
  PID: LongWord;
  I: Integer;
  SwitchingFreq: Double;

begin
  DeviceIndex := diOnly;

  PulseOutLabel[1 ] := PulseOutLabel1 ;
  PulseOutLabel[2 ] := PulseOutLabel2 ;
  PulseOutLabel[3 ] := PulseOutLabel3 ;
  PulseOutLabel[4 ] := PulseOutLabel4 ;
  PulseOutLabel[5 ] := PulseOutLabel5 ;
  PulseOutLabel[6 ] := PulseOutLabel6 ;
  PulseOutLabel[7 ] := PulseOutLabel7 ;
  PulseOutLabel[8 ] := PulseOutLabel8 ;
  PulseOutLabel[9 ] := PulseOutLabel9 ;
  PulseOutLabel[10] := PulseOutLabel10;
  PulseOutLabel[11] := PulseOutLabel11;
  PulseOutLabel[12] := PulseOutLabel12;
  PulseOutLabel[13] := PulseOutLabel13;
  PulseOutLabel[14] := PulseOutLabel14;
  PulseOutTrack[1 ] := PulseOutTrack1 ;
  PulseOutTrack[2 ] := PulseOutTrack2 ;
  PulseOutTrack[3 ] := PulseOutTrack3 ;
  PulseOutTrack[4 ] := PulseOutTrack4 ;
  PulseOutTrack[5 ] := PulseOutTrack5 ;
  PulseOutTrack[6 ] := PulseOutTrack6 ;
  PulseOutTrack[7 ] := PulseOutTrack7 ;
  PulseOutTrack[8 ] := PulseOutTrack8 ;
  PulseOutTrack[9 ] := PulseOutTrack9 ;
  PulseOutTrack[10] := PulseOutTrack10;
  PulseOutTrack[11] := PulseOutTrack11;
  PulseOutTrack[12] := PulseOutTrack12;
  PulseOutTrack[13] := PulseOutTrack13;
  PulseOutTrack[14] := PulseOutTrack14;

  Status := QueryDeviceInfo(DeviceIndex, @PID, nil, nil, nil, nil);
  if (Status <> ERROR_SUCCESS) or (PID <> $8020) then begin
    DetectForm := TDetectForm.Create(self);
    if DetectForm.ShowModal = mrOk then begin
      DeviceIndex := DetectForm.DeviceIndex;
      DetectForm.Free;
    end
    else begin
      DetectForm.Free;
      Application.Terminate;
      Exit;
    end;
  end;

  SwitchingFreq := 500;
  TicksPerCycle := Round(BaseClock / SwitchingFreq); //Ticks of the 10MHz base clock per PWM cycle.
  CTR_8254ModeLoad(DeviceIndex, 0, 0, 2, TicksPerCycle);
  for I := 1 to 14 do begin
    PulseOutTrack[I].Max := TicksPerCycle;
    PulseOutTrack[I].Frequency := TicksPerCycle div 100;
    PulseOutTrack[I].PageSize := TicksPerCycle div 10;
  end;

  for I := 1 to 14 do
    PulseOutTrackChange(PulseOutTrack[I])//CTR_8254Mode(DeviceIndex, 0, I, 1)
  ;
end;

procedure TMainForm.PulseOutTrackChange(Sender: TObject);
var
  iCounter: Integer;
  HighCt, LowCt: Integer;

begin
  iCounter := (Sender as TControl).Tag;
  if iCounter < Low(PulseOutTrack) then Exit;
  if iCounter > High(PulseOutTrack) then Exit;

  HighCt := PulseOutTrack[iCounter].Position;
  LowCt := TicksPerCycle - HighCt;

  if LowCt = 0 then
    CTR_8254Mode(DeviceIndex, 0, iCounter, 1)
  else
    CTR_8254ModeLoad(DeviceIndex, 0, iCounter, 1, LowCt)
  ;

  PulseOutLabel[iCounter].Caption := 'Counter ' + IntToStr(iCounter) + ': ' + FloatToStr(100 * HighCt / TicksPerCycle) + '%';

  //`@
end;

end.
